own mailserver, lots of improvements
[distro-setup] / mount-latest-subvol
1 #!/bin/bash
2 # Copyright (C) 2016 Ian Kelling
3 #
4 # Licensed under the Apache License, Version 2.0 (the "License");
5 # you may not use this file except in compliance with the License.
6 # You may obtain a copy of the License at
7 #
8 # http://www.apache.org/licenses/LICENSE-2.0
9 #
10 # Unless required by applicable law or agreed to in writing, software
11 # distributed under the License is distributed on an "AS IS" BASIS,
12 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13 # See the License for the specific language governing permissions and
14 # limitations under the License.
15
16 # usage: mount-latest-subvol
17
18 [[ $EUID == 0 ]] || exec sudo -E "$BASH_SOURCE" "$@"
19
20 errcatch() {
21 set -E; shopt -s extdebug
22 _err-trap() {
23 err=$?
24 exec >&2
25 set +x
26 echo "${BASH_SOURCE[1]}:${BASH_LINENO[0]}:in \`$BASH_COMMAND' returned $err"
27 bash-trace 2
28 echo "$0: exiting with code $err"
29 exit $err
30 }
31 trap _err-trap ERR
32 set -o pipefail
33 }
34 bash-trace() {
35 local -i argc_index=0 arg frame i start=${1:-1} max_indent=8 indent
36 local source
37 local extdebug=false
38 if [[ $(shopt -p extdebug) == *-s* ]]; then
39 extdebug=true
40 fi
41
42 for ((frame=0; frame < ${#FUNCNAME[@]}-1; frame++)); do
43 argc=${BASH_ARGC[frame]}
44 argc_index+=$argc
45 ((frame < start)) && continue
46 if (( ${#BASH_SOURCE[@]} > 1 )); then
47 source="${BASH_SOURCE[frame+1]}:${BASH_LINENO[frame]}:"
48 fi
49 indent=$((frame-start+1))
50 indent=$((indent < max_indent ? indent : max_indent))
51 printf "%${indent}s↳%sin \`%s" '' "$source" "${FUNCNAME[frame]}"
52 if $extdebug; then
53 for ((i=argc_index-1; i >= argc_index-argc; i--)); do
54 printf " %s" "${BASH_ARGV[i]}"
55 done
56 fi
57 echo \'
58 done
59 }
60 errcatch
61
62 tu() {
63 while read -r line; do
64 file="$1"
65 grep -xFq "$line" "$file" || tee -a "$file"<<<"$line"
66 done
67 }
68 e() { printf "%s\n" "$*"; "$@"; }
69 mnt() {
70 dir=$1
71 if ! mountpoint $dir &>/dev/null; then
72 mkdir -p $dir
73 e mount $dir
74 fi
75 }
76
77 ret=0
78
79 ##### begin setup fstab for subvols we care about ######
80 first_root_crypt=$(awk '$2 == "/" {print $1}' /etc/mtab)
81 tu /etc/fstab <<EOF
82 $first_root_crypt /a btrfs noatime,subvol=a 0 0
83 EOF
84 case $HOSTNAME in
85 treetowl|x2|frodo)
86 tu /etc/fstab <<EOF
87 $first_root_crypt /q btrfs noatime,subvol=q 0 0
88 $first_root_crypt /m btrfs noatime,subvol=m 0 0
89 /q/p /p none bind 0 0
90 EOF
91 ;;
92 esac
93 ##### end setup fstab for subvols we care about ######
94
95 for vol in q a m; do
96 d=/$vol
97 if ! awk '{print $2}' /etc/fstab | grep -xF $d &>/dev/null; then
98 continue
99 fi
100
101
102 ##### begin building up list of bind mounts ######
103 binds=() # list of bind mounts
104 roots=($d) # list of bind mounts, plus the original mount
105 while true; do
106 new_roots=()
107 for r in ${roots[@]}; do
108 # eg. when r=/q/p, for lines like
109 # /q/p /p none bind 0 0
110 # output /p
111 new_roots+=($(sed -rn "s#^$r/\S+\s+(\S+)\s+none\s+bind\s.*#\1#p" /etc/fstab))
112 done
113 (( ${#new_roots} )) || break
114 binds+=(${new_roots[@]})
115 roots=( ${new_roots[@]} )
116 done
117 ##### end building up list of bind mounts ######
118
119
120 # if latest is already mounted, make sure binds are mounted and move on
121 if e check-subvol-stale $d; then
122 for b in ${binds[@]}; do
123 mnt $b
124 done
125 continue
126 fi
127
128 last_snap=$(</nocow/btrfs-stale/$vol)
129 if [[ ! $last_snap ]]; then
130 echo "$0: error. empty last_snap var"
131 ret=1
132 continue
133 fi
134
135 umount_ret=true
136 unmounted=()
137 for dir in $(echo $d ${binds[*]}\ |tac -s\ ); do
138 if mountpoint $dir; then
139 if e umount -R $dir; then
140 unmounted+=($dir)
141 else
142 umount_ret=false
143 ret=1
144 echo "$0: failed to umount $dir"
145 break
146 fi
147 fi
148 done
149
150 if ! $umount_ret; then
151 for dir in ${unmounted[@]}; do
152 mnt $dir
153 done
154 continue
155 fi
156
157 cd /mnt/root
158 if [[ -e $vol ]]; then
159 e btrfs sub del $vol
160 fi
161 # Note, we make a few assumptions in this script, like
162 # $d was not a different subvol id than $vol, and
163 # things otherwise didn't get mounted very strangely.
164 e btrfs sub snapshot btrbk/$last_snap $vol
165 for dir in $d ${binds[@]}; do
166 e mnt $dir
167 done
168 stale_dir=/nocow/btrfs-stale
169 rm -f $stale_dir/$d
170 done
171
172 if [[ $HOSTNAME == treetowl ]]; then
173 # partitioned it with fai partitioner outside of fai,
174 # because it\'s worth it to have 1% space reserved for boot and
175 # swap partitions in case I ever want to boot off those drives.
176 # as root:
177 # . /a/bin/fai/fai-wrapper
178 # eval-fai-classfile /a/bin/fai/fai/config/class/51-multi-boot
179 # fai-setclass ROTATIONAL
180 # export LUKS_DIR=/q/root/luks/
181 # # because the partition nums existed already
182 # fai-setclass REPARTITION
183 # /a/bin/fai/fai/config/hooks/partition.DEFAULT
184
185 devs=(
186 ata-TOSHIBA_MD04ACA500_84REK6NTFS9A-part1
187 ata-TOSHIBA_MD04ACA500_84R2K773FS9A-part1
188 ata-TOSHIBA_MD04ACA500_8471K430FS9A-part1
189 ata-TOSHIBA_MD04ACA500_8481K493FS9A-part1
190 )
191 first=true
192 for dev in ${devs[@]}; do
193 if $first; then
194 first=false
195 tu /etc/fstab <<EOF
196 /dev/mapper/crypt_dev_$dev /i btrfs noatime,subvol=i,noauto 0 0
197 /dev/mapper/crypt_dev_$dev /mnt/iroot btrfs noatime,subvolid=0,noauto 0 0
198 EOF
199 fi
200 tu /etc/crypttab <<EOF
201 crypt_dev_$dev /dev/disk/by-id/$dev /q/root/luks/host-treetowl discard,luks
202 EOF
203 if [[ ! -e /dev/mapper/crypt_dev_$dev ]]; then
204 cryptdisks_start crypt_dev_$dev
205 fi
206 done
207 # note, could do an else here and have some kind of mount for /i
208 # on other hosts.
209 fi
210
211 exit $ret